!/////////////////////////////////////////////////////////////
	subroutine bgdmfp( bmatx, gmatx, dmatx, cartd, kgaus, lelfp )
!/////////////////////////////////////////////////////////////
      include 'param.h'
      include 'comst.h'
!
      dimension bmatx(3,8),gmatx(3,4),dmatx(3,3),cartd(2,6)
!
!     (nvafp = 8, nstfp = 3, ncomp =4)
!
!	-- [B] matrix and [G] matrix
!                                                                  | u1 |      
!                                                                  | v1 |      
!                                                                  | u2 |                                    | a1 |
!     |ex |   | dH1/dx   0     dN2/dx   0     ...  dH4/dx   0    | | v2 |   | dH5/dx dH6/dx    0      0    | | a2 |
!     |ey | = |   0    dH1/dy    0    dN2/dy  ...    0    dH4/dy | | u3 | + |   0      0     dN5/dy dN6/dy | | a3 |
!     |rxy|   | dH1/dy dH1/dx  dN2/dy dN2/dx  ...  dH4/dy dH4/dx | | v3 |   | dH5/dy dH6/dy  dN5/dx dN6/dx | | a4 |
!                                                                  | u4 |                                  
!            | u1 |      
!            | v1 |      
!            | u2 |      | a1 |    
!            | v2 |      | a2 |
!      = [B] | u3 | + [G]| a3 | 
!            | v3 |      | a4 |
!            | u4 |
!
!
!	-- [G] matrix
!
      do inode=1,4
      inod = (2*inode-1)
      jnod = 2*inode
      bmatx(1,inod) = cartd(1,inode)
      bmatx(1,jnod) = 0.
      bmatx(2,inod) = 0.
      bmatx(2,jnod) = cartd(2,inode)
      bmatx(3,inod) = cartd(2,inode)
      bmatx(3,jnod) = cartd(1,inode)
      enddo
!
!	-- [G] matrix
!
      gmatx(1,1) = cartd(1,5)
      gmatx(1,2) = cartd(1,6)
      gmatx(1,3) = 0.
      gmatx(1,4) = 0.
      gmatx(2,1) = 0.
      gmatx(2,2) = 0.
      gmatx(2,3) = cartd(2,5)
      gmatx(2,4) = cartd(2,6)
      gmatx(3,1) = cartd(2,5)
      gmatx(3,2) = cartd(2,6)
      gmatx(3,3) = cartd(1,5)
      gmatx(3,4) = cartd(1,6)
!
!	- store the components of [B] and [G] matrices
!     [B]
      do istfp=1,nstfp
      do ivafp=1,nvafp
      bmtfp(istfp,ivafp,kgaus,lelfp) = bmatx(istfp,ivafp)
      enddo
!     [G]
      do ivafp=1,4
      gmtfp(istfp,ivafp,kgaus,lelfp) = gmatx(istfp,ivafp)
      enddo
      enddo
!
!	-- [D] matrix
!
!     |sx |            |  1   p    0     | |ex |       |ex |
!     |sy | = E/(1-p2) |  p   1    0     | |ey | = [D] |ey |
!     |sxy|            |  0   0  (1-p)/2 | |rxy|       |rxy|
!
      y1 = young/(1.-poiss*poiss)
      do istfp=1,nstfp
      do jstfp=1,nstfp
      dmatx(istfp,jstfp) = 0.
      enddo
      enddo
      dmatx(1,1) = y1
      dmatx(2,2) = y1
      dmatx(1,2) = y1*poiss
      dmatx(2,1) = y1*poiss
      dmatx(3,3) = (1.-poiss)*y1/2.
!
      return
      end
!
