!//////////////////////////////////////////////////////////////////////////
      subroutine chekfp
!//////////////////////////////////////////////////////////////////////////
      include 'param.h'
      include 'comst.h'
!
      dimension delem(nval0),felem(nval0),dstrn(3),dstrs(3)
      dimension dumy1(3,8)
!
!     -- nstfp = 3, nvafp = 8 --
!   +-----------------------------------------------------------------+
!     delem : Delta Displacement of ELeMent
!     dstrs : Delta STResS at gauss point
!   +-----------------------------------------------------------------+
!
      eps = 1.e-30
!
      do ielfp=1,nelfp
!
!  -- calculate element displacement
!
      do ivafp=1,nvafp
      ifree = lomfp(ivafp,ielfp)
      if(ifree.eq.0) then
      delem(ivafp) = 0.0
      else
      delem(ivafp) = dnode(ifree)
      end if
      enddo
!
!  -- calculate element force
      do ivafp=1,nvafp
      felem(ivafp) = 0.
      do jvafp=1,nvafp
      felem(ivafp) = felem(ivafp) + &
                estfp(ivafp,jvafp,ielfp)*delem(jvafp)
      enddo
      enddo
      do ivafp=1,nvafp
      felfp(ivafp,ielfp) = felem(ivafp)
      enddo
!
!  -- calculate stress of Gaussian points
      kgaus = 0
      do igaus=1,ngaus
      do jgaus=1,ngaus
      kgaus = kgaus+1
!     
!     strain
!                 | u1 |                                | u1 |              
!                 | v1 |                                | v1 |             
!                 | u2 |      | a1 |                    | u2 |
!     |ex |       | v2 |      | a2 |                    | v2 |
!     |ey | = [B] | u3 | + [G]| a3 | = ( [B] - [G][T] ) | u3 |
!     |rxy|       | v3 |      | a4 |                    | v3 |
!                 | u4 |                                | u4 |
!
!     stress
!
!     |sx |       | ex |
!     |sy | = [D] | ey |
!     |txy|       | rxy|
!
!     [T] = Kaa-1 Kau
!
!     [G]*[T]
      call mmult2(dumy1,gmtfp(1,1,kgaus,ielfp),trmau(1,1,ielfp),nstfp,ncomp,nvafp)
!
      if(idfem.eq.1) then    
!     [B]
      do istfp=1,nstfp
      do ivafp=1,nvafp
      dumy1(istfp,ivafp) = bmtfp(istfp,ivafp,kgaus,ielfp)
      enddo
      enddo
      else if(idfem.eq.2) then
!     [B] - [G][T]
      do istfp=1,nstfp
      do ivafp=1,nvafp
      dumy1(istfp,ivafp) = bmtfp(istfp,ivafp,kgaus,ielfp) - dumy1(istfp,ivafp)
      enddo
      enddo
      endif
!
!     strain
!     {e} = [B] U or ( [B] - [G][T] ) U
      do istfp=1,nstfp
      dstrn(istfp) = 0.0
      do ivafp=1,nvafp
      dstrn(istfp) = dstrn(istfp) + dumy1(istfp,ivafp)*delem(ivafp)
      enddo
      enddo
!
!  -- stress
!     {s} = [D] {e}
      do istfp=1,nstfp
      dstrs(istfp) = 0.0
      do jstfp=1,nstfp
      dstrs(istfp) = dstrs(istfp) + dmtfp(istfp,jstfp,kgaus,ielfp)*dstrn(jstfp)
      enddo
      enddo
      do istfp=1,nstfp
      stsfp(istfp,kgaus,ielfp) = dstrs(istfp)
      enddo
!
!    - calculate principle stress at Gaussian points
!     ===========================
      call prinfp(kgaus,ielfp)
!     ===========================
!
      enddo
      enddo
!
      enddo
!
      return
      end
!
