!================================
!     comst.h
!================================
!
!	================== COMMON VARIABLES FOR STRUCTURE ==============
!
      common /contin/idfem,ndime,nnode,nrest
!          contin : CONTrol numbers of INput data
!              idfem : ID of FEM element (1: linear, 2: incompatible)
!              ndime : Number of DIMEnsions
!              nnode : Number of NODEs
!              nrest : Number of RESTraint nodes
!
      common /storst/nosnd(nout0),nopnd
!          storst : STORe reponses of STructure
!              nosnd : Number of Output Structural NoDe
!              nopnd : Number of OutPut NoDes
!
      common /nodedf/dnode(ndof0),fnode(ndof0),ddnod(ndof0),dfnod(ndof0)
!          nodedf : NODE Displacement and Force at each 
!              dnode : Displacement of NODE
!              fnode : Force of NODE
!              ddnod : Delta of Displacement of NODe
!              dfnod : Delta of Force of NODe
!     
      common /globnd/coord(ndim0,nnod0),dload(2*nnod0)
!          globnd : GLOBal data for structural NoDe
!              coord : COORDinate of node
!              dload : Discrete LOAD vector
!
      common /globst/grvty
!          globst : GLOBal data for STructure
!              grvty : GRaVTY acceleration
!
      common /globfr/ndres(2,nres0),&
                    nfree(2*nnod0),mhigh(ndof0),mdiag(ndof0+1),&
                    nstif,ndiag,ndofm
!          globfr : GLOBal FReedom in structure
!              ndres : NODe for ReStrained freedom
!              nfree : Number in FREEdom vector
!              mhigh : Matrix of skyline HIGHt
!              mdiag : Matrix of DIAGonal element number
!              nstif : Number of elements in STIFfness matrix
!              ndiag : Number of DIAGonal elements
!              ndofm : Number of Degree Of FreedoM
!
      common /globmt/gstif(ndof0*(ndof0+1)/2+1),&
                    gmass(ndof0)
!          globmt : GLOBal MaTrices for structural analysis
!              gstif : Global STIFfness matrix
!              gmass : Global MASS matrix
!
      common /elspro/young,poiss,dnsty
!          elspro : ELaStic PROperties
!              young : YOUNG's modulus (N/mm2)
!              poiss : POISSon ratio
!              dnsty : DeNSiTY (kg/m3)
!
!	================== COMMON VARIABLES FOR FEM PLATE ==============
!
      common /contfp/nelfp,nndfp,nmtfp,&
                    nstfp,nvafp,ngaus,ncomp
!          contfp : CONTrol numbers of Fem Plate
!              nelfp : Number of ELements (Fem Plate)
!              nndfp : Number of NoDes of Fem Plate
!              nmtfp : Number of Material Types of Fem Plate
!              nstfp : Number of STress at Gauss point of Fem Plate (3)
!              nvafp : Number of VAriables of Fem Plate (8)
!              ngaus : Number of GAUss Integration Points (2)
!              ncomp : Number of inCOMPatible modes (4)
!
      common /inpdfp/nodfp(nnde0,nefp0),matfp(nefp0),&
              profp(4,nmfp0)
!          inpdfp : INPut Data of Fem Plate
!              nodfp : NODe number of Fem Plate
!              matfp : MATerial number of Fem Plate
!              profp : material PROperties of Fem Plate
!
      common /lmatfp/lomfp(nval0,nefp0)
!          lmatfp : Location MATrix of Fem Plate
!              lomfp : LOcation Matrix of Fem Plate
!
      common /elemfp/estfp(nval0,nval0,nefp0),&
	          emsfp(nval0,nval0,nefp0),egfrc(nval0,nefp0)
!          elemfp : ELEment Matrices of Fem Plate
!              estfp : Element STiffness matrix of Fem Plate
!              emsfp : Element MaSs matrix of Fem Plate
!              egfrc : Element Gravity FoRCe vector
!
      common /gauspw/posgp(ngau0),weigp(ngau0)
!          gauspw : GAUSs Point and Weighting factors
!              posgp : POSition of Gauss Point
!              weigp : WEIghting factor of Gauss Point
!
      common /respfp/stsfp(ndim0,ngau0*ngau0,nefp0), &
                prnfp(ndim0,ngau0*ngau0,nefp0),felfp(nval0,nefp0),&
				dmtfp(3,3,ngau0*ngau0,nefp0), bmtfp(3,8,ngau0*ngau0,nefp0), &
				twwdj(ngau0*ngau0,nefp0), &
				gmtfp(3,4,ngau0*ngau0,nefp0),trmau(4,8,nefp0)
!          respfp : RESPonse of Fem Plate
!              stsfp : STresS at gauss points of Fem Plate
!              prnfp : PRiNciple stress at gauss points of Fem Plate
!              dmtfe : [D] Matrix of Fem Element
!              bmtfp : [B] Matrix of Fem Plate
!              twwdj : T*Wi*Wj*Det|J|
!              gmtfp : [G] Matrix of Fem Plate
!              trmau : TRansformation Matrix from U to A
!
!	================== COMMON VARIABLES FOR STATIC LOAD ==============
!
      common /static/pload(ndim0,nlod0),nlodn,nnlod(nlod0)
!          static : STATIC response analysis
!              pload : Point LOAD distribution
!              nlodn : total Number of LOaDed Nodes
!              nnlod : Node Number of LOaDed node
!
