!//////////////////////////////////////////////////////////////////////////
      subroutine datain
!     DATA INput
!//////////////////////////////////////////////////////////////////////////
      include 'param.h'
      include 'comst.h'
!
      character title*80
!
!  =====================
!	Structure Data
!  =====================
!
!  -- read title of analysis
      read(1,101) title
      write(2,201) title
!
!  -- read id of analysis method
!									idfem : ID of FEM element
!                                   (1: linear, 2: incompatible)
      read(1,*) idfem
      write(2,202) idfem
!
!  -- read the control numbers
!									nnode : Number of NODEs
!									nrest : Number of RESTrained nodes
      ndime = 2
      read(1,*) nnode,nrest
      write(2,203) nnode,nrest
!
! --- input nodal coordinates ---
!									coord : COORDinate of node
!										coord(1,I) : x-coordinate of node I
!										coord(2,I) : y-coordinate of node I
!									ndime : Number of DIMEnsion (2)
      write(2,204)
      do inode=1,nnode
      read(1,*) n,(coord(idime,inode),idime=1,ndime)
      write(2,205) inode,(coord(idime,inode),idime=1,ndime)
      enddo
!
!  -- input restraints
!									ndres(1,I) : I-th restrained node number
!									ndres(2,I) : restrained freedom
!												 = 0 : free
!												 = 1 : x
!												 = 2 : y
!												 = 12 : x and y
      write(2,206)
      do irest=1,nrest
      read(1,*) (ndres(j,irest),j=1,2)
      write(2,207) (ndres(j,irest),j=1,2)
      enddo
!
!  -- gravity acceleration
!									grvty : GRaViTY acceleration
      read(1,101) comnt
      write(2,208)
      read(1,*) grvty
      write(2,209) grvty
!
  101 format(a)
  201 format(a)
  202 format(/1x,'<FEM element>'/&
            3x,'idfem =',i5,' (1: linear, 2: incompatible)')
  203 format(/1x,'<Structural Parameters>'/&
            /1x,'control parameters'/&
            3x,'nnode =',i5,' (total Number of NODEs)'/&
            3x,'nrest =',i5,' (total Number of RESTrained nodes)')
  204 format(/1x,'nodal coordinate'/&
      ' --n--   ---x---   ---y---')
  205 format(i5,5f10.2)
  206 format(/1x,'input restraints'/' --n--   --dir.--')
  207 format(i5,i10)
  208 format(/1x,'gravity acceleration (mm/sec2)')
  209 format(5x,f15.5)
!
!  =====================
!	Element Data
!  =====================
!
      read(1,301) title
      write(2,401)
!
!  -- read the control number
!									nelfp : Number of ELements in FP
!									nmtfp : Number of Material Types of FP
!									nndfp : Number of NoDes of FP
!									nstfp : Number of STress at Gauss point of FP (3)
!									nvafp : Number of VAriables of FP (8)
!									ngaus : Number of GAUss Integration Points (2)
      nndfp = 4
      nstfp = 3
      nvafp = 8
      ngaus = 3
      ncomp = 4
!
      read(1,*) nelfp,nmtfp
      write(2,403) nelfp,nndfp,nmtfp,nstfp,nvafp,ngaus
!
!  -- read the element type and element node numbers
!									nodfp : NODe number of FP
!									matfp : MATerial number of FP
      write(2,405)
      do ielfp=1,nelfp
      read(1,*) n,(nodfp(indfp,ielfp),indfp=1,nndfp),&
                 matfp(ielfp)
      write(2,407) ielfp,(nodfp(indfp,ielfp),indfp=1,nndfp),&
                  matfp(ielfp)
      enddo
!
!  -- read the element properties
!					profp : material PROperties of FP
!                   1: Thickness(mm)
!                   2: Young's modulus (E) (N/mm2)'&
!                   3: Poisson ratio
!                   4: Density(kg/m3)          
      write(2,409)
      do imtfp=1,nmtfp
      read(1,*) n,(profp(i,imtfp),i=1,4)
      write(2,411) imtfp,(profp(i,imtfp),i=1,4)
      enddo
!
  301 format(a)
  401 format(/1x,'<Fem Plate>')
  403 format(/1x,'control parameters'/&
            3x,'nelfp =',i5/&
            3x,'nndfp =',i5/&
            3x,'nmtfp =',i5/&
            3x,'nstfp =',i5/&
            3x,'nvafp =',i5/&
            3x,'ngaus =',i5)
  405 format(/1x,'node numbers and element type'&
            /1x,'--n-- -na- -nb- -nc- -nd- -mt')
  407 format(1x,6i5)
  409 format(/1x,'material property'/&
            3x,'mt',&
            '   Thickness(mm)',&
            '        E(N/mm2)',&
            '   Poisson ratio',&
            '  Density(kg/m3)')          
  411 format(i5,4f16.4)
!
!  =====================
!	Load Data
!  =====================
!
      read(1,501) title
      write(2,601)
!
!     -- node number where load is acting
!									nlodn : total Number of LOaDed Nodes
!									nnlod : Node Number of LOaDed node
      read(1,*) nlodn
      write(2,603) nlodn
      read(1,*) (nnlod(ilodn),ilodn=1,nlodn)
      write(2,605) (nnlod(ilodn),ilodn=1,nlodn)
!
!     -- load distribution
!									pload : Point LOAD distribution
!										pload(1,I) : x-coordinate of node I
!										pload(2,I) : y-coordinate of node I
      write(2,607)
      do ilodn=1,nlodn
      read(1,*) n,(pload(idime,ilodn),idime=1,ndime)
      write(2,609) nnlod(ilodn),(pload(idime,ilodn),idime=1,ndime)
      enddo
!
 501  format(a)
 601  format(/1x,'<LOAD>')
 603  format(/1x,'total number of loaded nodes =',i5)
 605  format(1x,10i5)
 607  format(/1x,'load distribution'&
           /1x,'--n--     ---x---     ---y---')
 609  format(1x,i5,2f12.3)
!
      return
      end
!
