!//////////////////////////////////////////////////////////////////////////
      subroutine elstfp( bmatx, gmatx, dmatx,&
      stfuu, stfua, stfau, stfaa, dvalu )
!//////////////////////////////////////////////////////////////////////////
      include 'param.h'
      include 'comst.h'
!
      dimension bmatx(3,8),gmatx(3,4),dmatx(3,3)
      dimension dbmat(3,8),dgmat(3,4)
      dimension bmatt(8,3),gmatt(4,3)
      dimension stfuu(8,8),stfua(8,4),stfau(4,8),stfaa(4,4)
      dimension dmyuu(8,8),dmyua(8,4),dmyau(4,8),dmyaa(4,4)
      dimension wkm1(8,3),wkm2(4,3)
!
!     (nvafp = 8, nstfp = 3, ncomp =4)
!
!	-- matrix to obtain stress vector
!
!                    | u1 |                
!                    | v1 |               
!                    | u2 |         | a1 | 
!     |sx |          | v2 |         | a2 |
!     |sy | = [D][B] | u3 | + [D][G]| a3 | 
!     |txy|          | v3 |         | a4 |
!                    | u4 |
!                    | u4 |
!
!     [D][B]
      call mmult2( dbmat,dmatx,bmatx,nstfp,nstfp,nvafp )
!     [D][G]
      call mmult2( dgmat,dmatx,gmatx,nstfp,nstfp,ncomp )
!
!     [B]T
      do istfp=1,nstfp
      do ivafp=1,nvafp
      bmatt(ivafp,istfp) = bmatx(istfp,ivafp)
      enddo
      enddo
!     [G]T
      do istfp=1,nstfp
      do icomp=1,ncomp
      gmatt(icomp,istfp) = gmatx(istfp,icomp)
      enddo
      enddo
!
!     Kuu = [B]T [D] [B]
!
      call mmult2( dmyuu,bmatt,dbmat,nvafp,nstfp,nvafp )
      do ivafp=1,nvafp
      do jvafp=1,nvafp
      stfuu(ivafp,jvafp) = stfuu(ivafp,jvafp) + dmyuu(ivafp,jvafp)*dvalu
      enddo
      enddo
!
!     Kua = [B]T [D] [G]
!
      call mmult2( dmyua,bmatt,dgmat,nvafp,nstfp,ncomp )
      do ivafp=1,nvafp
      do jcomp=1,ncomp
      stfua(ivafp,jcomp) = stfua(ivafp,jcomp) + dmyua(ivafp,jcomp)*dvalu
      enddo
      enddo
!
!     Kau = [G]T [D] [B]
!
      call mmult2( dmyau,gmatt,dbmat,ncomp,nstfp,nvafp )
      do icomp=1,ncomp
      do jvafp=1,nvafp
      stfau(icomp,jvafp) = stfau(icomp,jvafp) + dmyau(icomp,jvafp)*dvalu
      enddo
      enddo
!
!     Kaa = [G]T [D] [G]
!
      call mmult2( dmyaa,gmatt,dgmat,ncomp,nstfp,ncomp )
      do icomp=1,ncomp
      do jcomp=1,ncomp
      stfaa(icomp,jcomp) = stfaa(icomp,jcomp) + dmyaa(icomp,jcomp)*dvalu
      enddo
      enddo
!
      return
      end    
