!//////////////////////////////////////////////////////////////////////////
	subroutine jacofp( djacb, cartd, elcod, deriv )
!	-- calculate cartesian derivatives of Jacobian matrix
!//////////////////////////////////////////////////////////////////////////
      implicit double precision (a-h,o-z)
!
      dimension elcod(3,4),shapf(6),deriv(2,6),cartd(2,6)
      dimension xjacm(2,2),xjaci(2,2)
!
!	-- create Jacobian matrix
!
!     [J] = | dx/dr  dy/dr | = | S(dNi/dr)xi  S(dNi/dr)yi |
!           | dx/ds  dy/ds |   | S(dNi/ds)xi  S(dNi/ds)yi |
!
      do idime=1,2
      do jdime=1,2
      xjacm(idime,jdime) = 0.
      do inodp=1,4
      xjacm(idime,jdime) = xjacm(idime,jdime) +&
     	deriv(idime,inodp)*elcod(jdime,inodp)
      enddo
      enddo
      enddo
!
!	-- calculate determinant and inverse of Jacobian matrix
!
!     [J]-1
!
      do idime=1,2
      do jdime=1,2
      xjaci(idime,jdime) = 0.
      enddo
      enddo
      djacb = xjacm(1,1)*xjacm(2,2)-xjacm(1,2)*xjacm(2,1)
      if(abs(djacb).gt.0.) then
      xjaci(1,1) = xjacm(2,2)/djacb
      xjaci(2,2) = xjacm(1,1)/djacb
      xjaci(1,2) = -xjacm(1,2)/djacb
      xjaci(2,1) = -xjacm(2,1)/djacb
      endif
!
!	-- calculate cartesian derivatives
!
!     | dH1/dx dH2/dx dH3/dx dH4/dx dH5/dx dH6/dx | = [J]-1 | dH1/dr dH2/dr dH3/dr dH4/dr dH5/dr dH6/dr |
!     | dH1/dy dN2/dy dN3/dy dH4/dy dH5/dy dH6/dy |         | dH1/ds dH2/ds dH3/ds dH4/ds dH5/ds dH6/ds |
!
      do idime=1,2
      do inodp=1,6
      cartd(idime,inodp) = 0.
      do jdime=1,2
      cartd(idime,inodp) = cartd(idime,inodp) +&
     	xjaci(idime,jdime)*deriv(jdime,inodp)
      enddo
      enddo
      enddo
!
      return
      end
!
