!     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!            FFFFF      EEEEEE       M     M
!           F          E            MM   MM
!          FFFFF      EEEEEE       M M M M
!         F          E            M  M  M
!        F          EEEEEE       M     M
!
!                                                Version 1.0
!
!     +++++++++++++ Fimite Element Method program ++++++++++++++
!
!         programmed by 
!         Dr. Taiki SAITO, 
!         Toyohashi University of Technology,
!         tsaito@ace.tut.ac.jp
!     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!           | datain                                            : input DATA INput
!           |
!           | frevec											: create FREedom VECtor
!           |
!           | locmfp											: create LOCation Matrix of Fem Plate (FP)
!           |
!           | skyprm -- | skymat								: calculate SKYline PaRaMeters / SKYline MATrix
!           |
!   main -- | 
!           |
!           | intres -- | intvst								: INiTial RESponse / INiTial Variables of STructure
!           |           | intvfp -- | gausfp					: INiTial Variables of FP / GAUss points of FP
!           |           | 
!           |           | gmatfp -- | elmtfp -- | shapfp		: Global MaTrix of FP / ELastic element MaTrix of FP / SHAPe function of FP
!           |           |           |           | jacofp		: JACObian
!           |           |           |           | bgdmfp		: [B],[G],[D] MaTrix
!           |           |           |           | hmatfp		: [H] MaTrix
!           |           |           |           | elstfp		: ELement STiffness matrix
!           |           |           |           | elmsfp		: ELement MasS matrix
!           |           |           |           | incomp		: Removing INCOMPatible displacement
!           |           |           | 
!           |           |           | addmat					: ADD element MATrix to global matrix
!           |           |           | addvec					: ADD element force VECtor to global force vector
!           |           |
!           |           | period -- | sspace					: natural PERIOD and mode shape / Sub SPACE method
!           |           |           | chekfp -- | prinfp		: CHEcK stress at gaussian point for FP / PRINcipal stress of FP
!           |           |
!           |           | lineeq -- | colsol                    : solve LINEar EQuation / COLumn SOLver
!           |           |
!           |           | chekfp -- | prinfp					: CHEcK stress at gaussian point for FP
!           |           |                                       
!           |           | strfor                                : from STRress to nodal FORce
!           |         
!           |         
!           | respns -- | stload								: RESPoNSe calculation / STatic LOAD
!           |           |
!           |           | lineeq -- | colsol					: solve LINEar EQuation / COLumn SOLver
!           |           |
!           |           | chekfp -- | prinfp					: CHEcK stress at gaussian point for FP
!           |           | strfor
!           |                                                   : PRINciple stress at gaussian point for FP
!           |
!           | outfin											: OUTPut FINal response
!
!
      include 'param.h'
      include 'comst.h'
!
!   -- OPEN files
      open(1, file='input_data.txt')
      open(2, file='output_data.txt')
      open(3, file='output_response.txt')
      open(4, file='output_mode.txt')
!
!==================================================
!
!   -- DATA INput --
!     ===============
      call datain
!     ===============
!
!   -- FREedom VECtor
!     ===============
      call frevec
!     ===============
!
!   -- LOCation Matrix of Fem Plate --
!     ===============
      call locmfp
!     ===============
!
!   -- SKYline PaRaMeters
!     ===============
      call skyprm
!     ===============
!
!   -- INiTial RESponse  --
!     ===============
      call intres
!     ===============
!
!   -- RESPonse of Nonlinear Static anaysis --
!     ===============
      call respns
!     ===============
!
!   -- OUTPut nodal response of STructure
!     ===============
      call outfin
!     ===============
!
      write(6,*) '>>>> Calculation is completed'
!
      close(1)
      close(2)
      close(3)
      close(4)
!
      write(6,*) 'press any key to continue .... '
      read(5,*)
!
      stop
      end
!