!//////////////////////////////////////////////////////////////////////////
      subroutine outfin
!     OUTPut FINal response
!//////////////////////////////////////////////////////////////////////////
      include 'param.h'
      include 'comst.h'
!
      dimension globd(2*nnod0),globf(2*nnod0)
      dimension doutn(ndim0,nnod0),foutn(ndim0,nnod0)
!
!   +----------------------------------------------+
!     globd : GLOBal Displacement vector
!     globf : GLOBal Force vector
!     doutn : Displacement of OUTput Node
!     foutn : Force of OUTput Node
!     shapf : SHAPe Function
!     gausd : GAUSs point Displacement
!   +----------------------------------------------+
!
!   +----------------------------------------------+
!	displacement of structural nodes
!   +----------------------------------------------+
!  -- initialize vectors
      do inode=1,2*nnode
      globd(inode) = 0.
      globf(inode) = 0.
      enddo
      do inode=1,nnode
      do idime=1,ndime
      doutn(idime,inode) = 0.
      foutn(idime,inode) = 0.
      enddo
      enddo
!
!  -- global response and force
      do inode=1,2*nnode
      nfr = nfree(inode)
      if(nfr.ne.0) then
      globd(inode) = dnode(nfr)
      globf(inode) = fnode(nfr)
      endif
      enddo
!
!  -- displacement at all nodes
      do inode=1,nnode
      do idime=1,ndime
      nfr = ndime*(inode-1)+idime
      doutn(idime,inode) = globd(nfr)
      enddo
      enddo
 !
 ! -- input data for ViewFEM
      write(3,101)
      write(3,103) nelfp
      write(3,102)
      do ielfp=1,nelfp
      write(3,103) ielfp,(nodfp(indfp,ielfp),indfp=1,nndfp)
      enddo
  101 format(1x,'Number of element')
  102 format(1x,'Node number of each element'&
            /1x,'   EL   na   nb   nc   nd')
  103 format(1x,5i5)

      write(3,201) 
      write(3,205) nnode
      write(3,202)
      write(3,203)
      do inode=1,nnode
      write(3,205) inode,coord(1,inode),coord(2,inode)
      enddo
      write(3,204)
      do inode=1,nnode
      write(3,205) inode,doutn(1,inode),doutn(2,inode)
      enddo
!
  201 format(1x,'Number of node')
  202 format(1x,'Displacement at all nodes')
  203 format(1x,'Initial position')
  204 format(1x,'Static displacement')
  205 format(1x,i5,2e15.5)
!
!  -- stress at Gauss point
      write(3,301)
      do ielfp=1,nelfp
      write(3,302) ielfp
!  -- stress at Gauss point
      do igaus=1,ngaus*ngaus
      degree = prnfp(3,igaus,ielfp)*(180.0/3.1415927)
      write(3,303) igaus,(prnfp(istfp,igaus,ielfp),istfp=1,3),degree
      enddo
      enddo
!
  301  format(1x,'Principal stress at gauss point')
  302  format(1x,'EL',i3,'             sx             sy', &
            '          theta    degree')
  303  format(1x,i5,3e15.5,f10.2)
!
!  -- force and displacement at nodes
      write(3,403)
      do inode=1,nnode
      write(3,404) inode,globf(ndime*(inode-1)+1),globf(ndime*(inode-1)+2)
      enddo
!
  403 format(1x,'Load distribution'&
             /1x,'    n              x              y')
  404 format(1x,i5,2e15.5)
      return
      end
!