!//////////////////////////////////////////////////////////////////////////
      subroutine period
!//////////////////////////////////////////////////////////////////////////
      include 'param.h'
      include 'comst.h'
!
      dimension stif(ndof0*(ndof0+1)/2+1),vec(ndof0)
      dimension eig(nmod0),eigv(ndof0,2*nmod0)
      dimension wx(nmod0),wy(nmod0),wz(nmod0),ww(nmod0)
      dimension betax(nmod0),betay(nmod0),betaz(nmod0)
      dimension evnod(2*nnod0)
!
      do istif=1,nstif
      stif(istif) = gstif(istif)
      enddo
!
      eps = 0.00000001
      pai = 3.1415926535
!
      km = 0
      do idofm=1,ndofm
      if(gmass(idofm).gt.eps) km = km + 1
      enddo
!
      n0 = ndof0
      nc0 = 2*nmod0
      nn = ndofm
      nnm = ndofm + 1
      nwk = nstif
      nwm = nstif
      nmode = 6
      if(nmode.gt.km) nmode = km
      nc = min(2*nmode,nmode+8)
      if(nc.gt.km) nc = nmode
      nnc = nc*(nc+1)/2
      nitem = 16
      ifss = 0
!
!     =================================================================
!     calculate eigen factors by sub-space method
      call sspace( stif, gmass, mdiag, eigv, eig, n0, nc0,&
        nn, nnm, nwk, nwm, nmode, nc, nnc, nitem, ifss )
!     =================================================================
!
!  -- save first natural frequency
      omega = sqrt(eig(1))
!
      write(4,201)
      do imode=1,nmode
!
!     -- M-orthonormalized eigen vector
      do idofm=1,ndofm
      vec(idofm) = eigv(idofm,imode)
      enddo
      sum = 0.
      do idofm=1,ndofm
      sum = sum + gmass(idofm)*vec(idofm)*vec(idofm)
      enddo
      do idofm=1,ndofm
      vec(idofm) = vec(idofm)/sqrt(sum)
      enddo
!
!     calculate principal stress at each mode
      do idofm=1,ndofm
      dnode(idofm) = vec(idofm)
      enddo
!     /////////////////
      call chekfp
!     /////////////////
!      
!     -- Eigen Vector at NODe (evnod)
      do inode=1,2*nnode
      nfr = nfree(inode)
      if(nfr.eq.0) then
      evnod(inode) = 0.
      else
      evnod(inode) = vec(nfr)
      endif
      enddo
!
!  -- print out the period and mode shape--
      write(4,202) imode, 2.*pai/sqrt(eig(imode))
      write(4,203)
      do inode=1,nnode
      nfr = ndime*(inode-1)
      write(4,204) inode,evnod(nfr+1),evnod(nfr+2)
      enddo
!
  201 format(1x,'Natural Period and Mode Shape')
  202 format(1x,'++ ',i2,'-mode ++'/f10.4)
  203 format(1x,'Mode')
  204 format(1x,i5,2e15.5)
!
!  -- stress at Gauss point
      dummy = 0.0
      write(4,301)
      do ielfp=1,nelfp
      write(4,302) ielfp
!  -- stress at Gauss point
      do igaus=1,ngaus*ngaus
      degree = prnfp(3,igaus,ielfp)*(180.0/3.1415927)
      write(4,303) igaus,(prnfp(istfp,igaus,ielfp),istfp=1,3),degree
      enddo
      enddo
!
  301  format(1x,'Principal stress at gauss point')
  302  format(1x,'EL',i3,'             sx             sy', &
            '          theta    degree')
  303  format(1x,i5,3e15.5,f10.2)
!
      enddo
!
!
      return
      end
!
