!//////////////////////////////////////////////////////////////////////////
	subroutine shapfp(r,s,shapf,deriv)
!//////////////////////////////////////////////////////////////////////////
	implicit double precision (a-h,o-z)
!
!	-- calculates shape function and their derivatives for 2-D element
!
      dimension shapf(6),deriv(2,6)
!
!
!                  s
!                  |
!           (x2)   |   (x1)
!             2----|----1
!             |    |    |
!             |    +----|---- r
!             |         |
!             3---------4
!           (x3)       (x4)
!                   
!
!	-- shape functions
!	H1, H2, H3, H4
!     x(r,s) = H1(r,s)*x1 + H2(r,s)*x2 + H3(r,s)*x3 + H4(r,s)*x4 
!              + H5(r,s)*a1 + H6(r,s)*a2      .... incompatible mode
      shapf(1) = (1.+r)*(1.+s)/4.
      shapf(2) = (1.-r)*(1.+s)/4.
      shapf(3) = (1.-r)*(1.-s)/4.
      shapf(4) = (1.+r)*(1.-s)/4.
      shapf(5) = (1.-r**2)
      shapf(6) = (1.-s**2)
     
!
!	-- shape fuction derivatives
!	dH1/dr, dH2/dr, dH3/dr, dH4/dr
!          dH5/dr, dH6/dr      .... incompatible mode
      deriv(1,1) = (1.+s)/4.
      deriv(1,2) = -(1.+s)/4.
      deriv(1,3) = -(1.-s)/4.
      deriv(1,4) = (1.-s)/4.
      deriv(1,5) = -2.*r
      deriv(1,6) = 0.
!	dH1/ds, dH2/ds, dH3/ds, dH4/ds
!          dH5/ds, dH6/ds      .... incompatible mode
      deriv(2,1) = (1.+r)/4.
      deriv(2,2) = (1.-r)/4.
      deriv(2,3) = -(1.-r)/4.
      deriv(2,4) = -(1.+r)/4.
      deriv(2,5) = 0.
      deriv(2,6) = -2.*s
!
      return
      end
!
